::mainScript <- self
::mainScope <- self.GetScriptScope()

::miniroundnum <- 0
::DEBUG <- false
IncludeScript("stopthattank/Sprinkles_Util.nut")
IncludeScript("stopthattank/TankHandler.nut")
IncludeScript("stopthattank/BossGiant.nut")
IncludeScript("stopthattank/TankMoney.nut")
IncludeScript("stopthattank/FootstepsSmall.nut")
IncludeScript("stopthattank/MainModels.nut")
IncludeScript("stopthattank/BombDeploy.nut")
IncludeScript("stopthattank/RedUpgrades.nut")
IncludeScript("stopthattank/PlayerDeath.nut")
IncludeScript("stopthattank/RobotHotHand.nut")
IncludeScript("stopthattank/RobotDeathSound.nut")
IncludeScript("stopthattank/RobotImpactSound.nut")
IncludeScript("stopthattank/RobotWeaponSounds.nut")
IncludeScript("stopthattank/give_tf_weapon/_master.nut")
IncludeScript("stopthattank/GiantWeaponsStats.nut")
IncludeScript("stopthattank/RobotBlood.nut")
//IncludeScript("stopthattank/StopThatTankTournament.nut")
IncludeScript("stopthattank/RedDestroyVoice.nut")


::ROOT <- getroottable();
if (!("ConstantNamingConvention" in ROOT))
{
    foreach (a,b in Constants)
        foreach (k,v in b)
            ROOT[k] <- v != null ? v : 0
}

if(FileToString("tankkills.txt") == null)
{
	StringToFile("tankkills.txt", "0")
	printl("TANK KILLS NOW TRACKING!")
}

ClearGameEventCallbacks()

for (local entity; entity = Entities.FindByName(entity, "revivesprites");) //is this needed?
{
    if (entity != null)
	    entity.Destroy()
}

function OnGameEvent_player_spawn(params)
{
    TankPlayerSpawn(params)
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    ModelSpawn(params)

    AddThinkToEnt(player,"PowerUpThink") //should rename this to the player think. handles the powerup timer and also replacing viewmodels.


    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        EntFireByHandle(self, "runscriptcode", "SmallFootsteps(activator)", 0.1, player, player)
        RobotBloodHide(params)
        SlappyHide(params)
        EntFireByHandle(self, "runscriptcode", "RomeVision(activator)", 0.1, player, player)
    }
    if (player.GetTeam() == TF_TEAM_RED)
    {
        HumanBloodShow(params)
    }
    EntFireByHandle(self, "runscriptcode", "HealthReset(activator)", 0.1, player, player)
    RedUpgrades(params)
}

function OnScriptHook_OnTakeDamage(params)
{

    local player = params.const_entity
    if (player.GetTeam() == 3)
    {
        if (player.GetMaxHealth() > 1)
        {
            if ( player.GetHealth() / player.GetMaxHealth() > 0.3 )
            {
                DispatchParticleEffect("bot_impact_light", params.damage_position, Vector(0, 0, 0));
            }
            else
            {
                DispatchParticleEffect( "bot_impact_heavy", params.damage_position, Vector(0, 0, 0) );
            }
        }
        GiantTakeDamage(params)
        //RobotBloodDecal(params)
        PlayerImpact(params)
        RobotWeaponImpact(params)
    }
}

function OnGameEvent_player_death(params)
{
    PlayerDeath(params)

    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        PlayerDeathLineStandard(params)
        if (AllowDeploy == false)
        {
            BombDeployStopped(player)
        }
		if(m_hFlagHolder == player)
		{
			m_bAllowBannerEffect = false
			m_hFlagHolder = null
			PowerupTimer = 0
		}
    }
    local attacker = GetPlayerFromUserID(params.attacker)
    if (player.IsMiniBoss())
    {
		m_bAllowBannerEffect = false
		m_hFlagHolder = null
		PowerupTimer = 0
        GiantDeath(params)
        local bossBar = Entities.FindByClassname(null, "monster_resource");
        NetProps.SetPropInt(bossBar,"m_iBossHealthPercentageByte", 0);
    }
    GiantDeath(params)
    //&& attacker.GetTeam() == TF_TEAM_RED
}

function Think()
{
	m_iRedPlayersAmount = redplayerarray.len()
}

function OnPostSpawn()
{
    Convars.SetValue("mp_tournament_redteamname", "MANN CO.")
    Convars.SetValue("mp_tournament_blueteamname", "GRAY GRAVEL CO.")
    CaptureZoneThink() //make a fake think so we don't override the main one!
    BombDeployPostSpawn()
    TankPostSpawn()
    SlappyThink()

	AddThinkToEnt(self, "Think")
}

function OnGameEvent_post_inventory_application(params)
{
    //InventoryApplicationMaster(params)
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)

    player.GTFW_Cleanup();

    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        SlappyHide(params)
    }
}

function OnGameEvent_teamplay_round_start(params)
{
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        GiantStart(params)
    }
    local cosmetic = null
	while (cosmetic = Entities.FindByClassname(cosmetic, "tf_wearable")) // Goes over every cosmetic item, executing code below
	{
		cosmetic.SetDrawEnabled(true)
	}
}

function OnGameEvent_teamplay_round_win(params)
{
    if (params.full_round == false)
    {
        miniroundnum++
    }
    for (local i = 1; i <= MaxPlayers; i++ )
    {
        local player = PlayerInstanceFromIndex(i)
        if (player == null)
        continue;
        if (player.IsMiniBoss())
        {
            GiantReset(player)
        }
    }
    local cosmetic = null
	while (cosmetic = Entities.FindByClassname(cosmetic, "tf_wearable")) // Goes over every cosmetic item, executing code below
	{
		cosmetic.SetDrawEnabled(true)
	}
}

__CollectGameEventCallbacks(this)