//// Util File Full of very useful things!

::DEPLOYTIME_SMALL 				<- 2.25;
::DEPLOYTIME_BIG 				<- 2.6;
::DEPLOYTIME_GENERIC 			<- 2.0;

::TF_PLAYERCLASS_GENERIC 		<- 0;
::TF_PLAYERCLASS_SCOUT 			<- 1;
::TF_PLAYERCLASS_SNIPER 		<- 2;
::TF_PLAYERCLASS_SOLDIER 		<- 3;
::TF_PLAYERCLASS_DEMOMAN 		<- 4;
::TF_PLAYERCLASS_MEDIC 			<- 5;
::TF_PLAYERCLASS_HEAVY 			<- 6;
::TF_PLAYERCLASS_PYRO 			<- 7;
::TF_PLAYERCLASS_SPY 			<- 8;
::TF_PLAYERCLASS_ENGINEER 		<- 9;
::TF_PLAYERCLASS_CIVILIAN		<- 10;

::TF_TEAM_ANY 					<- 0;
::TF_TEAM_SPECTATOR 			<- 1;
::TF_TEAM_RED					<- 2;
::TF_TEAM_BLUE 					<- 3;
::TF_TEAM_BOSS 					<- 5;

::DMG_GENERIC 					<- 1 << 0
::DMG_CRUSH 					<- 1 << 1
::DMG_BULLET 					<- 1 << 2
::DMG_SLASH 					<- 1 << 3
::DMG_BURN 						<- 1 << 4
::DMG_TRAIN 					<- 1 << 5
::DMG_FALL	 					<- 1 << 6
::DMG_BLAST 					<- 1 << 7
::DMG_CLUB	 					<- 1 << 8
::DMG_SHOCK 					<- 1 << 9
::DMG_SONIC 					<- 1 << 10
::DMG_ENERGYBEAM 				<- 1 << 11
::DMG_PREVENT_PHYSICS_FORCE  	<- 1 << 12
::DMG_NEVERGIB  				<- 1 << 13
::DMG_ALWAYSGIB  				<- 1 << 14
::DMG_DROWN 					<- 1 << 15
::DMG_PARALYZE 					<- 1 << 16
::DMG_SAWBLADE 					<- 1 << 17
::DMG_POISON 					<- 1 << 18
::DMG_RADIATION 				<- 1 << 19
::DMG_DROWNRECOVER 				<- 1 << 20
::DMG_CRITICAL 					<- 1 << 21
::DMG_MELEE  					<- 1 << 22
::DMG_REMOVENORAGDOLL  			<- 1 << 23
::DMG_PHYSGUN  					<- 1 << 24
::DMG_PLASMA  					<- 1 << 25
::DMG_AIRBOAT  					<- 1 << 26
::DMG_DISSOLVE  				<- 1 << 27
::DMG_BLAST_SURFACE  			<- 1 << 28
::DMG_BUCKSHOT  				<- 1 << 29
::DMG_HEADSHOT   				<- 1 << 30
::DMG_LASTGENERICFLAG    		<- 1 << 31

::TF_CLASS_NAMES <- [
    "generic",
    "scout",
    "sniper",
    "soldier",
    "demo",
    "medic",
    "heavy",
    "pyro",
    "spy",
    "engineer",
    "civilian"
];

::ROBOTMODEL_INDEX <- [
    GetModelIndex("models/player/fracture/bot_scout.mdl"),
    GetModelIndex("models/player/fracture/bot_scout.mdl"),
    GetModelIndex("models/player/fracture/bot_sniper.mdl"),
    GetModelIndex("models/player/fracture/bot_soldier.mdl"),
    GetModelIndex("models/player/fracture/bot_demo.mdl"),
    GetModelIndex("models/player/fracture/bot_medic.mdl"),
    GetModelIndex("models/player/fracture/bot_heavy.mdl"),
    GetModelIndex("models/player/fracture/bot_pyro.mdl"),
    GetModelIndex("models/player/fracture/bot_spy.mdl"),
    GetModelIndex("models/player/fracture/bot_engineer.mdl"),
    GetModelIndex("models/player/fracture/bot_scout.mdl"),
];

::TF_TEAM_NAMES <- [
    "None",
    "Spectator",
    "RED",
    "BLU",
    "Team4",
    "Boss",
];

::PrecacheParticle <- function(name)
{
    PrecacheEntityFromTable({ classname = "info_particle_system", effect_name = name })
}

::MAX_WEAPONS <- 8;

::MaxPlayers <- MaxClients().tointeger();

::tf_player_manager <- Entities.FindByClassname(null, "tf_player_manager");

::tf_gamerules <- Entities.FindByClassname(null, "tf_gamerules");

::UpgradeProxyManager <- Entities.FindByName(null, "upgrade_proxycontroler");

::GetPlayerUserID <- function(player)
{
    return NetProps.GetPropIntArray(tf_player_manager, "m_iUserID", player.entindex());
}

::SetEntityColor <- function(entity, r, g, b, a)
{
    local color = (r) | (g << 8) | (b << 16) | (a << 24);
    NetProps.SetPropInt(entity, "m_clrRender", color);
}

::GetEntityColor <- function(entity)
{
    local color = NetProps.GetPropInt(entity, "m_clrRender");
    local clr = {}
    clr.r <- color & 0xFF;
    clr.g <- (color >> 8) & 0xFF;
    clr.b <- (color >> 16) & 0xFF;
    clr.a <- (color >> 24) & 0xFF;
    return clr;
}

::Distance3D <- function(v1,v2)
{
	local a = (v2.x-v1.x);
	local b = (v2.y-v1.y);
	local c = (v2.z-v1.z);

	return sqrt((a*a)+(b*b)+(c*c));
}

::clamp <- function( val, minVal, maxVal )
{
	if ( maxVal < minVal )
		return maxVal;
	else if( val < minVal )
		return minVal;
	else if( val > maxVal )
		return maxVal;
	else
		return val;
}

::clampCeiling <- function(valueA, valueB)
{
    if (valueA < valueB)
        return valueA;
    return valueB;
}

::Remap <- function(value, low1, high1, low2, high2)
{
    return low2 + (value - low1) * (high2 - low2) / (high1 - low1)
}

::RemapVal <- function( val,  A,  B,  C,  D)
{
	if ( A == B )
		return val >= B ? D : C;
	return C + (D - C) * (val - A) / (B - A);
}

::RemapValClamped <- function( val,  A,  B,  C,  D)
{
	if ( A == B )
		return val >= B ? D : C;
	local cVal = (val - A) / (B - A);
	cVal = clamp( cVal, 0.0, 1.0 );

	return C + (D - C) * cVal;
}

::RemapValClampedRound <- function ( val,  A,  B,  C,  D)
{
	if ( A == B )
		return val >= B ? D : C;
	local cVal = (val - A) / (B - A);
	cVal = clamp( cVal, 0.0, 1.0 );

	local unrounded = C + (D - C) * cVal;
	return floor(unrounded / 100) * 100;
}

::CTFPlayer.GetPlayerName <- function()
{
	local player = this;
    return NetProps.GetPropString(player, "m_szNetname");
}

::CTFBot.GetPlayerName <- CTFPlayer.GetPlayerName

::CTFPlayer.GetPlayerSteamID <- function()
{
	local player = this;
    return NetProps.GetPropString(player, "m_szNetworkIDString");
}

::CTFBot.GetPlayerSteamID <- CTFPlayer.GetPlayerSteamID

::CTFPlayer.GetWeaponClassname <- function()
{
	local player = this;
	if (player.GetActiveWeapon() != null)
	{
		return player.GetActiveWeapon().GetClassname()
	}
	else
	{
		return ""
	}
}

::CTFBot.GetWeaponClassname <- CTFPlayer.GetWeaponClassname

::DamagePrint <- function(params)
{
	printl("OnScriptHook_OnTakeDamage")
    printl("----------------------------------------------------------------------")
    printl("const_entity: " + params.const_entity)
    printl("inflictor: " + params.inflictor)
    printl("weapon: " + params.weapon)
    printl("attacker: " + params.attacker)
    printl("damage: " + params.damage)
    printl("max_damage: " + params.max_damage)
    printl("damage_bonus: " + params.damage_bonus)
    printl("damage_bonus_provider: " + params.damage_bonus_provider)
    printl("const_base_damage: " + params.const_base_damage)
    printl("damage_force: " + params.damage_force)
    printl("damage_for_force_calc: " + params.damage_for_force_calc)
    printl("damage_position: " + params.damage_position)
    printl("reported_position: " + params.reported_position)
    printl("damage_type: " + params.damage_type)
    printl("damage_custom: " + params.damage_custom)
    printl("damage_stats: " + params.damage_stats)
    printl("force_friendly_fire: " + params.force_friendly_fire)
    printl("ammo_type: " + params.ammo_type)
    printl("player_penetration_count: " + params.player_penetration_count)
    printl("damaged_other_players: " + params.damaged_other_players)
    printl("crit_type: " + params.crit_type)
    printl("early_out: " + params.early_out)
    printl("----------------------------------------------------------------------")
}

::RomeVision <- function(player)
{
    player.AddCustomAttribute("vision opt in flags", 4, -1)
    player.AddCustomAttribute("always_transmit_so", 1, -1)
    //printl("Player: "+ player.GetPlayerName() + " Is Team: " + player.GetPlayerTeamString())
}

::CTFPlayer.ChangeHPBaseOnItem <- function()
{
	local player = this;
	local hp
	local weapon = GetPropEntityArray(player, "m_hMyWeapons", 1);

	if ((weapon.GetClassname() == "tf_weapon_buff_item") && (GetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex") == 226))
	{
		hp = player.GetMaxHealth() - 20
	}
	else
	{
		hp = player.GetMaxHealth()
	}

	return hp
}

::CTFBot.ChangeHPBaseOnItem <- CTFPlayer.ChangeHPBaseOnItem

::HealthReset <- function(player)
{
    player.SetHealth(player.GetMaxHealth())
    player.StopSound("MVM.GiantScoutLoop")
    player.StopSound("MVM.GiantSoldierLoop")
    player.StopSound("MVM.GiantDemomanLoop")
    player.StopSound("MVM.GiantHeavyLoop")
    player.StopSound("MVM.GiantPyroLoop")
	NetProps.SetPropString(player, "m_iName", "")
	player.RemoveCustomAttribute("max health additive bonus");
    player.RemoveCustomAttribute("health regen")
    player.RemoveCustomAttribute("backstab shield")
	player.Regenerate(true)
	local weapon = NetProps.GetPropEntityArray(player, "m_hMyWeapons", 1);
	if (weapon != null)
	{
		if (weapon.GetClassname() != "tf_wearable_demoshield")
		{
			NetProps.SetPropBool(player, "m_Shared.m_bShieldEquipped", false);
		}
	}
}

::CTFPlayer.GetPlayerClassString <- function()
{
	local player = this;
	return TF_CLASS_NAMES[player.GetPlayerClass()]
}

::CTFBot.GetPlayerClassString <- CTFPlayer.GetPlayerClassString

::CTFPlayer.GetPlayerTeamString <- function()
{
	local player = this;
	return TF_TEAM_NAMES[player.GetTeam()]
}

::CTFBot.GetPlayerTeamString <- CTFPlayer.GetPlayerTeamString

::CTFPlayer.GivePlayerWeapon <-  function(className, itemID, stats_function_Override=null)
{
	local player = this;

	local weapon = Entities.CreateByClassname(className);

		NetProps.SetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", itemID);
		NetProps.SetPropBool(weapon, "m_AttributeManager.m_Item.m_bInitialized", true);
		NetProps.SetPropBool(weapon, "m_bValidatedAttachedEntity", true);
		weapon.SetTeam(player.GetTeam());
		Entities.DispatchSpawn(weapon);

		// remove existing weapon in same slot
	for (local i = 0; i < MAX_WEAPONS; i++)
	{
		local heldWeapon = NetProps.GetPropEntityArray(player, "m_hMyWeapons", i);
		if (heldWeapon == null)
			continue;
		if (heldWeapon.GetSlot() != weapon.GetSlot())
			continue;
		heldWeapon.Destroy();
		NetProps.SetPropEntityArray(player, "m_hMyWeapons", null, i);
		break;
	}

	if (stats_function_Override ) {
		stats_function_Override(weapon, player);
		weapon.ReapplyProvision();
	}

	player.Weapon_Equip(weapon);
	player.Weapon_Switch(weapon);

	return weapon;
}

::CTFBot.GivePlayerWeapon <- CTFPlayer.GivePlayerWeapon

::AngleBetween <- function(v1,v2)
{
	local move_dir = (v2 - v1);


	return move_dir;
}

::VectorAngles <- function(v1,v2)
{
	local forward = (v2 - v1);
	local yaw, pitch;
	if ( forward.y == 0.0 && forward.x == 0.0 )
	{
		yaw = 0.0;
		if (forward.z > 0.0)
			pitch = 270.0;
		else
			pitch = 90.0;
	}
	else
	{
		yaw = (atan2(forward.y, forward.x) * 180.0 / Constants.Math.Pi);
		if (yaw < 0.0)
			yaw += 360.0;
		pitch = (atan2(-forward.z, forward.Length2D()) * 180.0 / Constants.Math.Pi);
		if (pitch < 0.0)
			pitch += 360.0;
	}

	return QAngle(0.0, yaw, 0.0);
}

::VectorAngles2 <- function(v1,v2)
{

	local forward = (v2 - v1);
	local yaw, pitch;
	if ( forward.y == 0.0 && forward.x == 0.0 )
	{
		yaw = 0.0;
		if (forward.z > 0.0)
			pitch = 270.0;
		else
			pitch = 90.0;
	}
	else
	{
		yaw = (atan2(forward.y, forward.x) * 180.0 / Constants.Math.Pi);
		if (yaw < 0.0){}
			//yaw += 360.0;
		pitch = (atan2(-forward.z, forward.Length2D()) * 180.0 / Constants.Math.Pi);
		if (pitch < 0.0){}
			//pitch += 360.0;
	}

	return QAngle(pitch, yaw, 0.0);
}

::VectorAngles3 <- function(v1,v2)
{
	local forward = (v2 - v1);
	local yaw, pitch;
	if ( forward.y == 0.0 && forward.x == 0.0 )
	{
		yaw = 0.0;
		if (forward.z > 0.0)
			pitch = 270.0;
		else
			pitch = 90.0;
	}
	else
	{
		yaw = (atan2(forward.y, forward.x) * 180.0 / Constants.Math.Pi);
		if (yaw < 0.0)
			yaw += 360.0;
		pitch = (atan2(-forward.z, forward.Length2D()) * 180.0 / Constants.Math.Pi);
		if (pitch < 0.0)
			pitch += 360.0;
	}

	return QAngle(pitch, yaw, 0.0);
}

::PlayerDisable <- function(ply,toggle = false)
{
	if(toggle)
	{
		ply.AddCustomAttribute("no_attack", 1, -1);
		ply.AddCustomAttribute("no_duck", 1, -1);
		ply.AddCustomAttribute("no_jump", 1, -1);
		ply.SetMoveType(0,0)
	}
	else
	{
    	ply.AddCustomAttribute("no_attack", 0, -1);
		if(!ply.IsMiniBoss()){ply.AddCustomAttribute("no_duck", 0, -1);}
		ply.AddCustomAttribute("no_jump", 0, -1);
		ply.SetMoveType(2,0)
	}
}

::PlayDeployAnim <- function(ply)
{
    ply.SetSequence(ply.LookupSequence("primary_deploybomb"));
}

::SetAttributeDelayed <- function(player ,attribute, attributenum = 0 || [], delay = 0.0, checkclass = false, checkboss = false, bossattributenum = 0 || []  )
{
    EntFireByHandle(mainScript, "RunScriptCode", AttributeSetter(player , attribute, attributenum, checkclass, checkboss, bossattributenum), delay, null, null); // call self to make a fake think!
}

function AttributeSetter(player , attribute, attributenum, checkclass, checkboss, bossattributenum)
{
    if(!checkclass)
	{
		player.AddCustomAttribute(attribute, attributenum, -1);
	}
	else
	{
		if(player.IsMiniBoss()){player.AddCustomAttribute(attribute, bossattributenum, -1);}
		else{player.AddCustomAttribute(attribute, attributenum, -1);}
	}
}

// By ficool2
if ( !( "GetPropInt" in getroottable() ) )
	foreach (k, v in NetProps.getclass())
		if (k != "IsValid")
			getroottable()[k] <- NetProps[k].bindenv(NetProps);